#' Parse the wildcards passed from Snakemake to the R scripts
#'
#' @param wildcards
#'
#' @return The wildcards represented as a named list.
#'
parse_wildcards <- function(wildcards) {

  split_wcs <- strsplit(wildcards, ",")[[1]]
  split_wcs <- vapply(split_wcs, strsplit, "=", FUN.VALUE = list(NULL))

  keys <- vapply(split_wcs, function(x) x[[1]], FUN.VALUE = character(1))
  values <- vapply(split_wcs, function(x) x[[2]], FUN.VALUE = character(1))

  out <- as.list(values)
  names(out) <- keys
  out
}

#wildcards <- "i=1,sim_id=prop_0.04_sim"
#parse_wildcards("i=1,sim_id=prop_0.04_sim")

# FIXME: Document and think about
fix_prob <- function(prob) {

  max_iter <- 5
  for (i in seq_len(max_iter)) {

    prob <- prob / sum(prob)

    if (identical(sum(prob), 1)) {
      break
    }

  }

  if (!identical(sum(prob), 1)) {
    stop("Probability correction failed.", call. = FALSE)
  }

  prob
}



